Index: issm/trunk/src/c/cores/controlm1qn3_core.cpp
===================================================================
--- issm/trunk/src/c/cores/controlm1qn3_core.cpp	(revision 18081)
+++ issm/trunk/src/c/cores/controlm1qn3_core.cpp	(revision 18301)
@@ -106,5 +106,5 @@
 
 	/*Get solution*/
-	SetControlInputsFromVectorx(femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,X);
+	SetControlInputsFromVectorx(femmodel,X);
 	ControlInputSetGradientx(femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,G);
 	femmodel->OutputControlsx(&femmodel->results);
@@ -131,8 +131,7 @@
 	FemModel   *femmodel  = (FemModel*)dzs;
 
-	/*Recover responses*/
-	int         num_responses;
-	int        *responses = NULL;
-	femmodel->parameters->FindParam(&responses,&num_responses,InversionCostFunctionsEnum);
+	/*Recover number of cost functions responses*/
+	int num_responses;
+	femmodel->parameters->FindParam(&num_responses,InversionNumCostFunctionsEnum);
 
 	/*Constrain input vector*/
@@ -147,5 +146,5 @@
 
 	/*Update control input*/
-	SetControlInputsFromVectorx(femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,X);
+	SetControlInputsFromVectorx(femmodel,X);
 
 	/*Recover some parameters*/
@@ -170,5 +169,4 @@
 	if(indic==0){
 		/*dry run, no gradient required*/
-		xDelete<int>(responses);
 		xDelete<IssmDouble>(XU);
 		xDelete<IssmDouble>(XL);
@@ -193,5 +191,4 @@
 
 	/*Clean-up and return*/
-	xDelete<int>(responses);
 	xDelete<IssmDouble>(XU);
 	xDelete<IssmDouble>(XL);
Index: issm/trunk/src/c/cores/controltao_core.cpp
===================================================================
--- issm/trunk/src/c/cores/controltao_core.cpp	(revision 18081)
+++ issm/trunk/src/c/cores/controltao_core.cpp	(revision 18301)
@@ -10,10 +10,19 @@
 #include "../solutionsequences/solutionsequences.h"
 
-#if defined (_HAVE_TAO_) && defined (_HAVE_PETSC_) && (_PETSC_MAJOR_ == 3 && _PETSC_MINOR_ > 1)
+#if defined (_HAVE_TAO_)
+#if defined (_HAVE_PETSC_) && (_PETSC_MAJOR_ == 3 && _PETSC_MINOR_ < 5)
 #include <tao.h>
+#else
+#include <petsctao.h>
+#endif
 
 /*Local prototype*/
+#if defined (_HAVE_PETSC_) && (_PETSC_MAJOR_ == 3 && _PETSC_MINOR_ < 5)
 int FormFunctionGradient(TaoSolver,Vec,IssmDouble*,Vec,void*);
 int IssmMonitor(TaoSolver,void*);
+#else
+int FormFunctionGradient(Tao,Vec,IssmDouble*,Vec,void*);
+int IssmMonitor(Tao,void*);
+#endif
 typedef struct {
 	FemModel* femmodel;
@@ -29,5 +38,9 @@
 	IssmDouble          fatol,frtol,gatol,grtol,gttol;
 	AppCtx              user;
+	#if defined (_HAVE_PETSC_) && (_PETSC_MAJOR_ == 3 && _PETSC_MINOR_ < 5)
 	TaoSolver           tao = 0;
+	#else
+	Tao                 tao = 0;
+	#endif
 	int                *control_list = NULL;
 	char               *algorithm    = NULL;
@@ -38,8 +51,10 @@
 
 	/*Initialize TAO*/
+	#if defined (_HAVE_PETSC_) && (_PETSC_MAJOR_ == 3 && _PETSC_MINOR_ < 5)
 	int argc; char **args=NULL;
 	PetscGetArgs(&argc,&args);
 	ierr = TaoInitialize(&argc,&args,(char*)0,"");
 	if(ierr) _error_("Could not initialize Tao");
+	#endif
 
 	/*Recover some parameters*/
@@ -93,5 +108,5 @@
 	G=new Vector<IssmDouble>(0); VecFree(&G->pvector->vector);
 	TaoGetGradientVector(tao,&G->pvector->vector);
-	SetControlInputsFromVectorx(femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,X);
+	SetControlInputsFromVectorx(femmodel,X);
 	ControlInputSetGradientx(femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,G);
 	femmodel->OutputControlsx(&femmodel->results);
@@ -111,11 +126,18 @@
 	delete X;
 	TaoDestroy(&tao);
+	#if defined (_HAVE_PETSC_) && (_PETSC_MAJOR_ == 3 && _PETSC_MINOR_ < 5)
 	TaoFinalize();
-}
-int FormFunctionGradient(TaoSolver tao, Vec Xpetsc, IssmDouble *fcn,Vec G,void *userCtx){
+	#endif
+}
+
+#if defined (_HAVE_PETSC_) && (_PETSC_MAJOR_ == 3 && _PETSC_MINOR_ < 5)
+int FormFunctionGradient(TaoSolver tao, Vec Xpetsc, IssmDouble *fcn,Vec G,void *uservoid){
+#else
+int FormFunctionGradient(Tao tao, Vec Xpetsc, IssmDouble *fcn,Vec G,void *uservoid){
+#endif
 
 	/*Retreive arguments*/
 	int                  solution_type;
-	AppCtx              *user            = (AppCtx *)userCtx;
+	AppCtx              *user            = (AppCtx *)uservoid;
 	FemModel            *femmodel        = user->femmodel;
 	Vector<IssmDouble>  *gradient        = NULL;
@@ -127,5 +149,5 @@
 	/*Set new variable*/
 	//VecView(X,PETSC_VIEWER_STDOUT_WORLD);
-	SetControlInputsFromVectorx(femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,X);
+	SetControlInputsFromVectorx(femmodel,X);
 	delete X;
 
@@ -152,5 +174,9 @@
 	return 0;
 }
+#if defined (_HAVE_PETSC_) && (_PETSC_MAJOR_ == 3 && _PETSC_MINOR_ < 5)
 int IssmMonitor(TaoSolver tao, void *userCtx){
+#else
+int IssmMonitor(Tao tao, void *userCtx){
+#endif
 
 	int         its,num_responses;
Index: issm/trunk/src/c/cores/controlvalidation_core.cpp
===================================================================
--- issm/trunk/src/c/cores/controlvalidation_core.cpp	(revision 18301)
+++ issm/trunk/src/c/cores/controlvalidation_core.cpp	(revision 18301)
@@ -0,0 +1,102 @@
+/*!\file: controlvalidation_core.cpp
+ * \brief: core of the control solution 
+ */ 
+
+#include "./cores.h"
+#include "../toolkits/toolkits.h"
+#include "../classes/classes.h"
+#include "../shared/shared.h"
+#include "../modules/modules.h"
+
+void controlvalidation_core(FemModel* femmodel){
+
+	int         solution_type,n;
+	IssmDouble  j0,j;
+	IssmDouble  Ialpha,exponent,alpha;
+	IssmDouble *G = NULL;
+	IssmDouble *X = NULL;
+	IssmDouble *X0= NULL;
+
+	/*Solution and Adjoint core pointer*/
+	void (*solutioncore)(FemModel*) = NULL;
+	void (*adjointcore)(FemModel*)  = NULL;
+
+	/*Recover parameters used throughout the solution*/
+	femmodel->parameters->FindParam(&solution_type,SolutionTypeEnum);
+	femmodel->parameters->SetParam(false,SaveResultsEnum);
+
+	/*Get initial guess*/
+	Vector<IssmDouble> *Xpetsc = NULL;
+	GetVectorFromControlInputsx(&Xpetsc,femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,"value");
+	Xpetsc->GetSize(&n);
+	X0 = Xpetsc->ToMPISerial();
+	delete Xpetsc;
+
+	/*Allocate Gradient and current vector*/
+	G = xNew<IssmDouble>(n);
+	X = xNew<IssmDouble>(n);
+
+	/*out of solution_type, figure out solution core and adjoint function pointer*/
+	CorePointerFromSolutionEnum(&solutioncore,femmodel->parameters,solution_type);
+	AdjointCorePointerFromSolutionEnum(&adjointcore,solution_type);
+
+	if(VerboseControl()) _printf0_("   Compute Initial solution\n");
+	solutioncore(femmodel);
+	if(VerboseControl()) _printf0_("   Compute Adjoint\n");
+	adjointcore(femmodel);
+	if(VerboseControl()) _printf0_("   Compute Initial cost function\n");
+	femmodel->CostFunctionx(&j0,NULL,NULL);
+	if(VerboseControl()) _printf0_("   Compute Gradient\n");
+	Gradjx(&G,NULL,femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters);
+	for(int i=0;i<n;i++) G[i] = -G[i];
+
+	/*Range of tests*/
+	IssmDouble exp0 = 0.;
+	IssmDouble incr = -0.2;
+	IssmDouble exp1 = -10.;
+	int        num  = reCast<int,IssmDouble>((exp1-exp0)/incr);
+
+	/*Allocate output*/
+	IssmDouble* output = xNew<IssmDouble>(2*num);
+
+	/*Start loop*/
+	_printf0_("       alpha      Ialpha \n");
+	_printf0_("_________________________\n");
+	for(int m=0;m<num;m++){
+
+		/*Calculate alpha = 10^-exponent*/
+		exponent = exp0+m*incr;
+		alpha    = pow(10.,exponent);
+
+		/*Create new vector*/
+		for(int i=0;i<n;i++) X[i] = X0[i] + alpha;
+
+		/*Calculate j(k+alpha delta k) */
+		SetControlInputsFromVectorx(femmodel,X);
+		solutioncore(femmodel);
+		femmodel->CostFunctionx(&j,NULL,NULL);
+
+		IssmDouble Den = 0.;
+		for(int i=0;i<n;i++) Den += alpha * G[i] * 1.;
+		Ialpha = fabs((j - j0)/Den - 1.);
+
+		_printf0_(" " << setw(11) << setprecision (5)<<alpha<<" " << setw(11) << setprecision (5)<<Ialpha<<"\n");
+		output[m*2+0] = alpha;
+		output[m*2+1] = Ialpha;
+	}
+
+	/*output*/
+	#ifdef _HAVE_ADOLC_
+	IssmPDouble* J_passive=xNew<IssmPDouble>(2*num);
+	for(int i=0;i<2*num;i++) J_passive[i]=reCast<IssmPDouble>(output[i]);
+	femmodel->results->AddObject(new GenericExternalResult<IssmPDouble*>(femmodel->results->Size()+1,JEnum,J_passive,num,2,1,0));
+	xDelete<IssmPDouble>(J_passive);
+	#else
+	femmodel->results->AddObject(new GenericExternalResult<IssmPDouble*>(femmodel->results->Size()+1,JEnum,output,num,2,1,0));
+	#endif
+
+	/*Clean up and return*/
+	xDelete<IssmDouble>(G);
+	xDelete<IssmDouble>(X);
+	xDelete<IssmDouble>(X0);
+}
Index: issm/trunk/src/c/cores/cores.h
===================================================================
--- issm/trunk/src/c/cores/cores.h	(revision 18081)
+++ issm/trunk/src/c/cores/cores.h	(revision 18301)
@@ -19,5 +19,4 @@
 void adjointbalancethickness_core(FemModel* femmodel);
 void adjointbalancethickness2_core(FemModel* femmodel);
-void gradient_core(FemModel* femmodel,int n=0,bool orthogonalize=false);
 void stressbalance_core(FemModel* femmodel);
 void hydrology_core(FemModel* femmodel);
@@ -30,4 +29,5 @@
 void controltao_core(FemModel* femmodel);
 void controlm1qn3_core(FemModel* femmodel);
+void controlvalidation_core(FemModel* femmodel);
 void masstransport_core(FemModel* femmodel);
 void depthaverage_core(FemModel* femmodel);
Index: issm/trunk/src/c/cores/damage_core.cpp
===================================================================
--- issm/trunk/src/c/cores/damage_core.cpp	(revision 18081)
+++ issm/trunk/src/c/cores/damage_core.cpp	(revision 18301)
@@ -22,13 +22,7 @@
 	//first recover parameters common to all solutions
 	femmodel->parameters->FindParam(&save_results,SaveResultsEnum);
-	femmodel->parameters->FindParam(&dakota_analysis,QmuIsdakotaEnum);
 	femmodel->parameters->FindParam(&solution_type,SolutionTypeEnum);
 	femmodel->parameters->FindParam(&numoutputs,DamageEvolutionNumRequestedOutputsEnum);
 	if(numoutputs) femmodel->parameters->FindParam(&requested_outputs,&numoutputs,DamageEvolutionRequestedOutputsEnum);
-
-	if(dakota_analysis && solution_type!=TransientSolutionEnum){
-		femmodel->SetCurrentConfiguration(DamageEvolutionAnalysisEnum);
-		ResetConstraintsx(femmodel);
-	}
 
 	if(VerboseSolution()) _printf0_("   computing damage\n");
Index: issm/trunk/src/c/cores/masstransport_core.cpp
===================================================================
--- issm/trunk/src/c/cores/masstransport_core.cpp	(revision 18081)
+++ issm/trunk/src/c/cores/masstransport_core.cpp	(revision 18301)
@@ -26,16 +26,8 @@
 	femmodel->parameters->FindParam(&isFS,FlowequationIsFSEnum);
 	femmodel->parameters->FindParam(&isfreesurface,MasstransportIsfreesurfaceEnum);
-	femmodel->parameters->FindParam(&dakota_analysis,QmuIsdakotaEnum);
 	femmodel->parameters->FindParam(&solution_type,SolutionTypeEnum);
 	femmodel->parameters->FindParam(&domaintype,DomainTypeEnum);
 	femmodel->parameters->FindParam(&numoutputs,MasstransportNumRequestedOutputsEnum);
 	if(numoutputs) femmodel->parameters->FindParam(&requested_outputs,&numoutputs,MasstransportRequestedOutputsEnum);
-
-	/*for qmu analysis, reinitialize velocity so that fake sensitivities do not show up as a result of a different restart of the convergence at each trial.*/
-	if(dakota_analysis && solution_type==MasstransportSolutionEnum){
-		InputDuplicatex(femmodel,QmuSurfaceEnum,SurfaceEnum);
-		InputDuplicatex(femmodel,QmuThicknessEnum,ThicknessEnum);
-		InputDuplicatex(femmodel,QmuBaseEnum,BaseEnum);
-	}
 
 	/*Calculate new Surface Mass Balance (SMB)*/
Index: issm/trunk/src/c/cores/stressbalance_core.cpp
===================================================================
--- issm/trunk/src/c/cores/stressbalance_core.cpp	(revision 18081)
+++ issm/trunk/src/c/cores/stressbalance_core.cpp	(revision 18301)
@@ -30,17 +30,8 @@
 	femmodel->parameters->FindParam(&isHO,FlowequationIsHOEnum);
 	femmodel->parameters->FindParam(&isFS,FlowequationIsFSEnum);
-	femmodel->parameters->FindParam(&dakota_analysis,QmuIsdakotaEnum);
 	femmodel->parameters->FindParam(&save_results,SaveResultsEnum);
 	femmodel->parameters->FindParam(&solution_type,SolutionTypeEnum);
 	femmodel->parameters->FindParam(&numoutputs,StressbalanceNumRequestedOutputsEnum);
 	if(numoutputs) femmodel->parameters->FindParam(&requested_outputs,&numoutputs,StressbalanceRequestedOutputsEnum);
-
-	/*for qmu analysis, reinitialize velocity so that fake sensitivities do not show up as a result of a different restart of the convergence at each trial.*/
-	if(dakota_analysis && solution_type==StressbalanceSolutionEnum){
-		InputDuplicatex(femmodel,QmuVxEnum,VxEnum);
-		InputDuplicatex(femmodel,QmuVyEnum,VyEnum);
-		if(domaintype==Domain3DEnum) InputDuplicatex(femmodel,QmuVzEnum,VzEnum);
-		if(isFS) InputDuplicatex(femmodel,QmuPressureEnum,PressureEnum);
-	}
 
 	/*Compute slopes if necessary */
Index: issm/trunk/src/c/cores/thermal_core.cpp
===================================================================
--- issm/trunk/src/c/cores/thermal_core.cpp	(revision 18081)
+++ issm/trunk/src/c/cores/thermal_core.cpp	(revision 18301)
@@ -22,20 +22,8 @@
 	/*first recover parameters common to all solutions*/
 	femmodel->parameters->FindParam(&save_results,SaveResultsEnum);
-	femmodel->parameters->FindParam(&dakota_analysis,QmuIsdakotaEnum);
 	femmodel->parameters->FindParam(&solution_type,SolutionTypeEnum);
 	femmodel->parameters->FindParam(&isenthalpy,ThermalIsenthalpyEnum);
 	femmodel->parameters->FindParam(&numoutputs,ThermalNumRequestedOutputsEnum);
 	if(numoutputs) femmodel->parameters->FindParam(&requested_outputs,&numoutputs,ThermalRequestedOutputsEnum);
-
-	if(dakota_analysis && solution_type!=TransientSolutionEnum){
-		InputDuplicatex(femmodel,QmuVxMeshEnum,VxMeshEnum);
-		InputDuplicatex(femmodel,QmuVyMeshEnum,VyMeshEnum);
-		InputDuplicatex(femmodel,QmuVzMeshEnum,VzMeshEnum);
-		InputDuplicatex(femmodel,QmuTemperatureEnum,TemperatureEnum);
-		InputDuplicatex(femmodel,QmuMeltingEnum,BasalforcingsMeltingRateEnum);
-		InputDuplicatex(femmodel,QmuMaterialsRheologyBEnum,MaterialsRheologyBEnum);
-		femmodel->SetCurrentConfiguration(ThermalAnalysisEnum);
-		ResetConstraintsx(femmodel);
-	}
 
 	if(isenthalpy){
Index: issm/trunk/src/c/cores/transient_core.cpp
===================================================================
--- issm/trunk/src/c/cores/transient_core.cpp	(revision 18081)
+++ issm/trunk/src/c/cores/transient_core.cpp	(revision 18301)
@@ -60,37 +60,4 @@
 	step=0;
 	time=starttime;
-
-	/*for qmu analysis, reinitialize velocity so that fake sensitivities do not show up as a result of a different restart of the convergence at each trial.*/
-	if(dakota_analysis){
-		if(isstressbalance){
-			InputDuplicatex(femmodel,QmuVxEnum,VxEnum);
-			InputDuplicatex(femmodel,QmuVyEnum,VyEnum);
-			if(domaintype==Domain3DEnum){
-				InputDuplicatex(femmodel,QmuVzEnum,VzEnum);
-				if(isFS)InputDuplicatex(femmodel,QmuPressureEnum,PressureEnum);
-			}
-		}
-		if(ismasstransport || isgroundingline){
-			InputDuplicatex(femmodel,QmuThicknessEnum,ThicknessEnum);
-			InputDuplicatex(femmodel,QmuSurfaceEnum,SurfaceEnum);
-			InputDuplicatex(femmodel,QmuBaseEnum,BaseEnum);
-			InputDuplicatex(femmodel,QmuMaskIceLevelsetEnum,MaskIceLevelsetEnum);
-		}
-		if(isgroundingline) InputDuplicatex(femmodel,QmuMaskGroundediceLevelsetEnum,MaskGroundediceLevelsetEnum);
-		if(isthermal && domaintype==Domain3DEnum){
-			//Update Vertex Position after updating Thickness and Bed
-			femmodel->SetCurrentConfiguration(MasstransportAnalysisEnum);
-			femmodel->UpdateVertexPositionsx();
-			InputDuplicatex(femmodel,QmuVxMeshEnum,VxMeshEnum);
-			InputDuplicatex(femmodel,QmuVyMeshEnum,VyMeshEnum);
-			InputDuplicatex(femmodel,QmuVzMeshEnum,VzMeshEnum);
-			InputDuplicatex(femmodel,QmuTemperatureEnum,TemperatureEnum);
-			InputDuplicatex(femmodel,QmuMeltingEnum,BasalforcingsMeltingRateEnum);
-			InputDuplicatex(femmodel,QmuMaterialsRheologyBEnum,MaterialsRheologyBEnum);
-			//Reset Thermal Constraints
-			femmodel->SetCurrentConfiguration(ThermalAnalysisEnum);
-			ResetConstraintsx(femmodel);
-		}
-	}
 
 	while(time < finaltime - (yts*DBL_EPSILON)){ //make sure we run up to finaltime.
@@ -183,4 +150,8 @@
 			}
 		}
+
+		/*Calculate new Basal melting on Floating ice*/
+		FloatingiceMeltingRatex(femmodel);
+		
 		if(isgia){
 			if(VerboseSolution()) _printf0_("   computing glacial isostatic adjustment\n");
Index: issm/trunk/src/c/datastructures/DataSet.cpp
===================================================================
--- issm/trunk/src/c/datastructures/DataSet.cpp	(revision 18081)
+++ issm/trunk/src/c/datastructures/DataSet.cpp	(revision 18301)
@@ -24,6 +24,15 @@
 
 /*Constructors/Destructors*/
-/*FUNCTION DataSet::DataSet(){{{*/
-DataSet::DataSet(){
+DataSet::DataSet(){/*{{{*/
+
+	sorted=0;
+	numsorted=0;
+	sorted_ids=NULL;
+	id_offsets=NULL;
+
+}
+/*}}}*/
+DataSet::DataSet(int dataset_enum){/*{{{*/
+	enum_type=dataset_enum;
 
 	sorted=0;
@@ -33,45 +42,41 @@
 }
 /*}}}*/
-/*FUNCTION DataSet::DataSet(int dataset_enum){{{*/
-DataSet::DataSet(int dataset_enum){
-	enum_type=dataset_enum;
-
-	sorted=0;
-	sorted_ids=NULL;
-	id_offsets=NULL;
-
-}
-/*}}}*/
-/*FUNCTION DataSet::Copy{{{*/
-DataSet*   DataSet::Copy(void){
-
-	vector<Object*>::iterator object;
+DataSet* DataSet::Copy(void){/*{{{*/
+
+	vector<Object*>::iterator obj;
 	Object* object_copy=NULL;
 
-	DataSet* copy=new DataSet(enum_type);
-
-	copy->sorted=sorted;
-	copy->presorted=presorted;
-	if(sorted_ids){
-		copy->sorted_ids=xNew<int>(objects.size());
-		xMemCpy<int>(copy->sorted_ids,sorted_ids,objects.size());
-	}
-	if(id_offsets){
-		copy->id_offsets=xNew<int>(objects.size());
-		xMemCpy<int>(copy->id_offsets,id_offsets,objects.size());
-	}
+	DataSet* copy=new DataSet(this->enum_type);
+
+	copy->sorted=this->sorted;
+	copy->numsorted=this->numsorted;
+	copy->presorted=this->presorted;
 
 	/*Now we need to deep copy the objects: */
-	for ( object=objects.begin() ; object < objects.end(); object++ ){
-
-		/*Call echo on object: */
-		object_copy = (*object)->copy();
+	for ( obj=this->objects.begin() ; obj < this->objects.end(); obj++ ){
+		/*Call copy on object: */
+		object_copy = (*obj)->copy();
 		copy->AddObject(object_copy);
 	}
+
+	/*Build id_offsets and sorted_ids*/
+	int objsize = this->numsorted;
+	if(this->sorted && objsize>0 && this->id_offsets){	
+		/*Allocate new ids*/
+		copy->id_offsets=xNew<int>(objsize);
+		xMemCpy<int>(copy->id_offsets,this->id_offsets,objsize);
+	}
+	else copy->id_offsets=NULL;
+	if(this->sorted && objsize>0 && this->sorted_ids){
+		/*Allocate new ids*/
+		copy->sorted_ids=xNew<int>(objsize);
+		xMemCpy<int>(copy->sorted_ids,this->sorted_ids,objsize);
+	}
+	else copy->sorted_ids=NULL;
+
 	return copy;
 }
 /*}}}*/
-/*FUNCTION DataSet::~DataSet{{{*/
-DataSet::~DataSet(){
+DataSet::~DataSet(){/*{{{*/
 	clear();
 	xDelete<int>(sorted_ids);
@@ -81,6 +86,5 @@
 
 /*Specific methods*/
-/*FUNCTION DataSet::AddObject{{{*/
-int  DataSet::AddObject(Object* object){
+int   DataSet::AddObject(Object* object){/*{{{*/
 
 	_assert_(this);
@@ -90,6 +94,5 @@
 }
 /*}}}*/
-/*FUNCTION DataSet::clear{{{*/
-void  DataSet::clear(){
+void  DataSet::clear(){/*{{{*/
 
 /*  use reverse_iterator for efficiency in matlab memory manager
@@ -108,6 +111,5 @@
 }
 /*}}}*/
-/*FUNCTION DataSet::DeleteObject{{{*/
-int  DataSet::DeleteObject(Object* object){
+int   DataSet::DeleteObject(Object* object){/*{{{*/
 
 	vector<Object*>::iterator iterator;
@@ -123,6 +125,5 @@
 }
 /*}}}*/
-/*FUNCTION DataSet::DeepEcho{{{*/
-void DataSet::DeepEcho(){
+void  DataSet::DeepEcho(){/*{{{*/
 
 	vector<Object*>::iterator object;
@@ -140,6 +141,5 @@
 }
 /*}}}*/
-/*FUNCTION DataSet::Echo{{{*/
-void DataSet::Echo(){
+void  DataSet::Echo(){/*{{{*/
 
 	vector<Object*>::iterator object;
@@ -158,11 +158,9 @@
 }
 /*}}}*/
-/*FUNCTION DataSet::GetEnum(){{{*/
-int  DataSet::GetEnum(){
+int   DataSet::GetEnum(){/*{{{*/
 	return enum_type;
 }
 /*}}}*/
-/*FUNCTION DataSet::GetEnum(int offset){{{*/
-int   DataSet::GetEnum(int offset){
+int   DataSet::GetEnum(int offset){/*{{{*/
 
 	return objects[offset]->ObjectEnum();
@@ -170,6 +168,5 @@
 }
 /*}}}*/
-/*FUNCTION DataSet::GetObjectByOffset{{{*/
-Object* DataSet::GetObjectByOffset(int offset){
+Object* DataSet::GetObjectByOffset(int offset){/*{{{*/
 
 	/*Check index in debugging mode*/
@@ -182,6 +179,5 @@
 }
 /*}}}*/
-/*FUNCTION DataSet::GetObjectById{{{*/
-Object* DataSet::GetObjectById(int* poffset,int eid){
+Object* DataSet::GetObjectById(int* poffset,int eid){/*{{{*/
 
 	int id_offset;
@@ -189,5 +185,5 @@
 
 	_assert_(this);
-	if(!sorted)_error_("trying to binary search on a non-sorted dataset!");
+	if(!sorted || objects.size()>numsorted)_error_("trying to binary search on a non-sorted dataset!");
 
 	/*Carry out a binary search on the sorted_ids: */
@@ -206,6 +202,5 @@
 }
 /*}}}*/
-/*FUNCTION DataSet::Presort{{{*/
-void DataSet::Presort(){
+void  DataSet::Presort(){/*{{{*/
 
 	/*vector of objects is already sorted, just allocate the sorted ids and their
@@ -214,6 +209,6 @@
 
 		/*Delete existing ids*/
-		xDelete<int>(sorted_ids);
-		xDelete<int>(id_offsets);
+		if(sorted_ids) xDelete<int>(sorted_ids);
+		if(id_offsets) xDelete<int>(id_offsets);
 
 		/*Allocate new ids*/
@@ -229,9 +224,9 @@
 
 	/*set sorted flag: */
+	numsorted=objects.size();
 	sorted=1;
 }
 /*}}}*/
-/*FUNCTION DataSet::Size{{{*/
-int  DataSet::Size(void){
+int   DataSet::Size(void){/*{{{*/
 	_assert_(this!=NULL);
 
@@ -239,6 +234,5 @@
 }
 /*}}}*/
-/*FUNCTION DataSet::Sort{{{*/
-void DataSet::Sort(){
+void  DataSet::Sort(){/*{{{*/
 
 	/*Only sort if we are not already sorted: */
Index: issm/trunk/src/c/datastructures/DataSet.h
===================================================================
--- issm/trunk/src/c/datastructures/DataSet.h	(revision 18081)
+++ issm/trunk/src/c/datastructures/DataSet.h	(revision 18301)
@@ -25,4 +25,5 @@
 		int             sorted;
 		int             presorted;
+		int             numsorted;
 		int*            sorted_ids;
 		int*            id_offsets;
Index: issm/trunk/src/c/kml/KMLFileReadUtils.cpp
===================================================================
--- issm/trunk/src/c/kml/KMLFileReadUtils.cpp	(revision 18081)
+++ issm/trunk/src/c/kml/KMLFileReadUtils.cpp	(revision 18301)
@@ -16,6 +16,5 @@
 /*}}}*/
 
-/*FUNCTION  KMLFileToken(FILE* fid,int* pncom=NULL,char*** ppcom=NULL) {{{*/
-char* KMLFileToken(FILE* fid,
+char* KMLFileToken(FILE* fid,/*{{{*/
 				   int* pncom=NULL,char*** ppcom=NULL){
 
@@ -144,6 +143,5 @@
 }
 /*}}}*/
-/*FUNCTION  KMLFileTokenComment(FILE* fid) {{{*/
-char* KMLFileTokenComment(FILE* fid){
+char* KMLFileTokenComment(FILE* fid){/*{{{*/
 
 /*  check for comment in the file and read it  */
@@ -208,6 +206,5 @@
 }
 /*}}}*/
-/*FUNCTION  KMLFileTokenBuffer {{{*/
-void KMLFileTokenBuffer(char** pbuffer,int* pibuf,int* pbuflen,
+void KMLFileTokenBuffer(char** pbuffer,int* pibuf,int* pbuflen,/*{{{*/
 						int c,
 						int bufblk){
@@ -237,6 +234,5 @@
 }
 /*}}}*/
-/*FUNCTION  KMLFileTagName {{{*/
-char* KMLFileTagName(char* pname,
+char* KMLFileTagName(char* pname,/*{{{*/
 					 char* ktag){
 
@@ -245,6 +241,5 @@
 }
 /*}}}*/
-/*FUNCTION  KMLFileTagName {{{*/
-char* KMLFileTagName(char* pname,int *m,int maxlen,
+char* KMLFileTagName(char* pname,int *m,int maxlen,/*{{{*/
 					 char* ktag){
 
@@ -290,6 +285,5 @@
 }
 /*}}}*/
-/*FUNCTION  KMLFileTagAttrib {{{*/
-int KMLFileTagAttrib(KML_Object* kobj,
+int KMLFileTagAttrib(KML_Object* kobj,/*{{{*/
 					 char* ktag){
 
@@ -339,6 +333,5 @@
 }
 /*}}}*/
-/*FUNCTION  KMLFileTokenParse {{{*/
-int KMLFileTokenParse(int* pival,
+int KMLFileTokenParse(int* pival,/*{{{*/
 					  char* ktag,
 					  FILE* fid){
@@ -375,6 +368,5 @@
 }
 /*}}}*/
-/*FUNCTION  KMLFileTokenParse {{{*/
-int KMLFileTokenParse(bool* pbval, char* ktag, FILE* fid){
+int KMLFileTokenParse(bool* pbval, char* ktag, FILE* fid){/*{{{*/
 
 	int     ival;
@@ -410,6 +402,5 @@
 }
 /*}}}*/
-/*FUNCTION  KMLFileTokenParse {{{*/
-char* KMLFileTokenParse(char* pstr,
+char* KMLFileTokenParse(char* pstr,/*{{{*/
 						char* ktag,
 						FILE* fid){
@@ -420,6 +411,5 @@
 }
 /*}}}*/
-/*FUNCTION  KMLFileTokenParse {{{*/
-char* KMLFileTokenParse(char* pstr,int *m,int maxlen,
+char* KMLFileTokenParse(char* pstr,int *m,int maxlen,/*{{{*/
 						char* ktag,
 						FILE* fid){
@@ -472,6 +462,5 @@
 }
 /*}}}*/
-/*FUNCTION  KMLFileTokenParse {{{*/
-int KMLFileTokenParse(float* pfval,
+int KMLFileTokenParse(float* pfval,/*{{{*/
 					  char* ktag,
 					  FILE* fid){
@@ -507,6 +496,5 @@
 }
 /*}}}*/
-/*FUNCTION  KMLFileTokenParse {{{*/
-int KMLFileTokenParse(double* pdval,
+int KMLFileTokenParse(double* pdval,/*{{{*/
 					  char* ktag,
 					  FILE* fid){
@@ -542,6 +530,5 @@
 }
 /*}}}*/
-/*FUNCTION  KMLFileTokenParse {{{*/
-int KMLFileTokenParse(double **pdval,int* m,int maxlen,
+int KMLFileTokenParse(double **pdval,int* m,int maxlen,/*{{{*/
 					  char* ktag,
 					  FILE* fid){
@@ -610,6 +597,5 @@
 }
 /*}}}*/
-/*FUNCTION  KMLFileTokenParse {{{*/
-int KMLFileTokenParse(double **pdval,int* m,int n,int maxlen,
+int KMLFileTokenParse(double **pdval,int* m,int n,int maxlen,/*{{{*/
 					  char* ktag,
 					  FILE* fid){
@@ -682,6 +668,5 @@
 }
 /*}}}*/
-/*FUNCTION  KMLFileTagSkip {{{*/
-int KMLFileTagSkip(char* ktag, FILE* fid){
+int KMLFileTagSkip(char* ktag, FILE* fid){/*{{{*/
 
 	char*   kstr;
Index: issm/trunk/src/c/kml/KML_Attribute.cpp
===================================================================
--- issm/trunk/src/c/kml/KML_Attribute.cpp	(revision 18081)
+++ issm/trunk/src/c/kml/KML_Attribute.cpp	(revision 18301)
@@ -16,6 +16,5 @@
 
 /*Constructors/destructor/copy*/
-/*FUNCTION KML_Attribute::KML_Attribute(){{{*/
-KML_Attribute::KML_Attribute(){
+KML_Attribute::KML_Attribute(){/*{{{*/
 
 	name      =NULL;
@@ -24,6 +23,5 @@
 }
 /*}}}*/
-/*FUNCTION KML_Attribute::~KML_Attribute(){{{*/
-KML_Attribute::~KML_Attribute(){
+KML_Attribute::~KML_Attribute(){/*{{{*/
 
 	if (name      ) xDelete<char>(name);
@@ -34,6 +32,5 @@
 
 /*Other*/
-/*FUNCTION KML_Attribute::Echo {{{*/
-void  KML_Attribute::Echo(){
+void  KML_Attribute::Echo(){/*{{{*/
 
 	int   i;
@@ -48,6 +45,5 @@
 }
 /*}}}*/
-/*FUNCTION KML_Attribute::DeepEcho {{{*/
-void  KML_Attribute::DeepEcho(){
+void  KML_Attribute::DeepEcho(){/*{{{*/
 
 	char  indent[81]="";
@@ -58,6 +54,5 @@
 }
 /*}}}*/
-/*FUNCTION KML_Attribute::DeepEcho {{{*/
-void  KML_Attribute::DeepEcho(const char* indent){
+void  KML_Attribute::DeepEcho(const char* indent){/*{{{*/
 
 	int   i;
@@ -72,6 +67,5 @@
 }
 /*}}}*/
-/*FUNCTION KML_Attribute::Write {{{*/
-void  KML_Attribute::Write(FILE* filout,const char* indent){
+void  KML_Attribute::Write(FILE* filout,const char* indent){/*{{{*/
 
 //  attributes always written in keyword line of kml_object
@@ -82,6 +76,5 @@
 }
 /*}}}*/
-/*FUNCTION KML_Attribute::Read {{{*/
-void  KML_Attribute::Read(FILE* fid,char* kstr){
+void  KML_Attribute::Read(FILE* fid,char* kstr){/*{{{*/
 
 //  attributes always read in keyword line of kml_object
@@ -92,6 +85,5 @@
 }
 /*}}}*/
-/*FUNCTION KML_Attribute::Alloc {{{*/
-void  KML_Attribute::Alloc(const char* namei,const char* valuei){
+void  KML_Attribute::Alloc(const char* namei,const char* valuei){/*{{{*/
 
 	name =xNew<char>(strlen(namei )+1);
@@ -104,6 +96,5 @@
 }
 /*}}}*/
-/*FUNCTION KML_Attribute::Add {{{*/
-void  KML_Attribute::Add(DataSet* attrib){
+void  KML_Attribute::Add(DataSet* attrib){/*{{{*/
 
 	attrib->AddObject((Object*)this);
@@ -112,6 +103,5 @@
 }
 /*}}}*/
-/*FUNCTION KML_Attribute::Get {{{*/
-void  KML_Attribute::Get(char** pvalueo,char* deflt){
+void  KML_Attribute::Get(char** pvalueo,char* deflt){/*{{{*/
 
 	if (!value || !strlen(value)) {
Index: issm/trunk/src/c/kml/KML_ColorStyle.cpp
===================================================================
--- issm/trunk/src/c/kml/KML_ColorStyle.cpp	(revision 18081)
+++ issm/trunk/src/c/kml/KML_ColorStyle.cpp	(revision 18301)
@@ -18,6 +18,5 @@
 
 /*Constructors/destructor/copy*/
-/*FUNCTION KML_ColorStyle::KML_ColorStyle(){{{*/
-KML_ColorStyle::KML_ColorStyle(){
+KML_ColorStyle::KML_ColorStyle(){/*{{{*/
 
 	strcpy(color     ,"ffffffff");
@@ -26,6 +25,5 @@
 }
 /*}}}*/
-/*FUNCTION KML_ColorStyle::~KML_ColorStyle(){{{*/
-KML_ColorStyle::~KML_ColorStyle(){
+KML_ColorStyle::~KML_ColorStyle(){/*{{{*/
 
 	;
@@ -35,6 +33,5 @@
 
 /*Other*/
-/*FUNCTION KML_ColorStyle::Echo {{{*/
-void  KML_ColorStyle::Echo(){
+void  KML_ColorStyle::Echo(){/*{{{*/
 
 	bool  flag=true;
@@ -48,6 +45,5 @@
 }
 /*}}}*/
-/*FUNCTION KML_ColorStyle::DeepEcho {{{*/
-void  KML_ColorStyle::DeepEcho(){
+void  KML_ColorStyle::DeepEcho(){/*{{{*/
 
 	char  indent[81]="";
@@ -58,6 +54,5 @@
 }
 /*}}}*/
-/*FUNCTION KML_ColorStyle::DeepEcho {{{*/
-void  KML_ColorStyle::DeepEcho(const char* indent){
+void  KML_ColorStyle::DeepEcho(const char* indent){/*{{{*/
 
 	bool  flag=true;
@@ -69,6 +64,5 @@
 }
 /*}}}*/
-/*FUNCTION KML_ColorStyle::Write {{{*/
-void  KML_ColorStyle::Write(FILE* filout,const char* indent){
+void  KML_ColorStyle::Write(FILE* filout,const char* indent){/*{{{*/
 
 	KML_SubStyle::Write(filout,indent);
@@ -82,6 +76,5 @@
 }
 /*}}}*/
-/*FUNCTION KML_ColorStyle::Read {{{*/
-void  KML_ColorStyle::Read(FILE* fid,char* kstr){
+void  KML_ColorStyle::Read(FILE* fid,char* kstr){/*{{{*/
 
 /*  process field within opening and closing tags  */
Index: issm/trunk/src/c/kml/KML_Comment.cpp
===================================================================
--- issm/trunk/src/c/kml/KML_Comment.cpp	(revision 18081)
+++ issm/trunk/src/c/kml/KML_Comment.cpp	(revision 18301)
@@ -16,6 +16,5 @@
 
 /*Constructors/destructor/copy*/
-/*FUNCTION KML_Comment::KML_Comment(){{{*/
-KML_Comment::KML_Comment(){
+KML_Comment::KML_Comment(){/*{{{*/
 
 	value     =NULL;
@@ -23,6 +22,5 @@
 }
 /*}}}*/
-/*FUNCTION KML_Comment::~KML_Comment(){{{*/
-KML_Comment::~KML_Comment(){
+KML_Comment::~KML_Comment(){/*{{{*/
 
 	if (value     ) xDelete<char>(value);
@@ -32,6 +30,5 @@
 
 /*Other*/
-/*FUNCTION KML_Comment::Echo {{{*/
-void  KML_Comment::Echo(){
+void  KML_Comment::Echo(){/*{{{*/
 
 	bool  flag=true;
@@ -43,6 +40,5 @@
 }
 /*}}}*/
-/*FUNCTION KML_Comment::DeepEcho {{{*/
-void  KML_Comment::DeepEcho(){
+void  KML_Comment::DeepEcho(){/*{{{*/
 
 	char  indent[81]="";
@@ -53,6 +49,5 @@
 }
 /*}}}*/
-/*FUNCTION KML_Comment::DeepEcho {{{*/
-void  KML_Comment::DeepEcho(const char* indent){
+void  KML_Comment::DeepEcho(const char* indent){/*{{{*/
 
 	bool  flag=true;
@@ -64,6 +59,5 @@
 }
 /*}}}*/
-/*FUNCTION KML_Comment::Write {{{*/
-void  KML_Comment::Write(FILE* filout,const char* indent){
+void  KML_Comment::Write(FILE* filout,const char* indent){/*{{{*/
 
 	if (strncmp(&value[0]              ,"<!--",4))
@@ -76,6 +70,5 @@
 }
 /*}}}*/
-/*FUNCTION KML_Comment::Read {{{*/
-void  KML_Comment::Read(FILE* fid,char* kstr){
+void  KML_Comment::Read(FILE* fid,char* kstr){/*{{{*/
 
 //  comments always read as part of KMLFileToken
@@ -86,6 +79,5 @@
 }
 /*}}}*/
-/*FUNCTION KML_Comment::Alloc {{{*/
-void  KML_Comment::Alloc(const char* valuei){
+void  KML_Comment::Alloc(const char* valuei){/*{{{*/
 
 	value=xNew<char>(strlen(valuei)+1);
@@ -95,6 +87,5 @@
 }
 /*}}}*/
-/*FUNCTION KML_Comment::Add {{{*/
-void  KML_Comment::Add(DataSet* commnt){
+void  KML_Comment::Add(DataSet* commnt){/*{{{*/
 
 	commnt->AddObject((Object*)this);
@@ -103,6 +94,5 @@
 }
 /*}}}*/
-/*FUNCTION KML_Comment::Get {{{*/
-void  KML_Comment::Get(char** pvalueo){
+void  KML_Comment::Get(char** pvalueo){/*{{{*/
 
 	*pvalueo=xNew<char>(strlen(value)+1);
